﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

#endregion

namespace Stopwatch
{
    partial class frmStopwatch : Form
    {
        public frmStopwatch()
        {
            InitializeComponent();
        }
        
        DateTime startTime;
        TimeSpan stoppedTime;
        DateTime stopTime;

        private void btnExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnStartStop_Click(object sender, EventArgs e)
        {
            if (btnStartStop.Text == "Start")
            {
                // initial to running state
                startTime = DateTime.Now;
                stoppedTime = new TimeSpan(0);
                timDisplay.Enabled = true;
                btnStartStop.Text = "Stop";
                btnExit.Enabled = false;
            }
            else if (btnStartStop.Text == "Stop")
            {
                // running to stopped state
                stopTime = DateTime.Now;
                timDisplay.Enabled = false;
                btnStartStop.Text = "Restart";
                btnReset.Enabled = true;
                btnExit.Enabled = true;
            }
            else if (btnStartStop.Text == "Restart") 
            {
                // stopped to running state
                stoppedTime += DateTime.Now - stopTime;
                timDisplay.Enabled = true;
                btnStartStop.Text = "Stop";
                btnReset.Enabled = false;
                btnExit.Enabled = false;
            }
        }
       private string HMS(TimeSpan t)
       {
            string hs, ms, ss;
            // Break time down into hours, minutes, and seconds
            hs = t.Hours.ToString();
            ms = t.Minutes.ToString();
            ss = t.Seconds.ToString();
            if (t.Hours  < 10)
                hs = "0" + hs;
            if (t.Minutes < 10)
                ms = "0" + ms;
            if (t.Seconds < 10)
                ss = "0" + ss;
            return (hs + ":" + ms + ":" + ss );
        }

        private void timDisplay_Tick(object sender, EventArgs e)
        {
            TimeSpan totalTime;
            TimeSpan runningTime;
            // Determine total and running times in seconds
            totalTime = DateTime.Now - startTime;
            runningTime = totalTime - stoppedTime;
            // Display times
            lblTotal.Text = HMS(totalTime);
            lblRunning.Text = HMS(runningTime);
        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            // return to initial state
            lblRunning.Text = "00:00:00";
            lblTotal.Text = "00:00:00";
            btnStartStop.Text = "Start";
            btnReset.Enabled = false;
        }
    }
}